; WM_NCCALCSIZE & WM_NCHITTEST
; draft v.2007-12-26
; http://geocities.com/xmemor/2lz/tinyasm.html
; ("Tiny apps + sources (masm32)")

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32

.data
 _ft        db " (%d)   "
 _class     db "WM_NCCALCSIZE  &  WM_NCHITTEST",0
 _about     db "by kero <geocities.com/xmemor>, v.2007-12-26",0
 _text      db "Try  Mouse Wheel  &  Right Click",0
 _HTCLIENT  db "HTCLIENT",0 
 _HTNOWHERE db "HTNOWHERE",0
 _HTCAPTION db "HTCAPTION",0
 _HTMENU    db "HTMENU",0
 _OTHER     db "?",0
 _menutmplt db 0,0,0,0,80h,0,0,0,'M',0,'E',0,'N',0,'U',0,0,0
 len        dd 50

.data?
 hmenu      dd ?
 count      dd ?
 
.code

WndProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local rt:RECT
  local rt2:RECT
  local ps:PAINTSTRUCT
  local buf[MAX_PATH]:BYTE  
  local lprm:DWORD

  .if uMsg==WM_DESTROY
    invoke PostQuitMessage,0

  .elseif uMsg==WM_CREATE
    invoke LoadMenuIndirect,offset _menutmplt
    mov hmenu,eax
    invoke SetMenu,hWnd,eax    
    jmp @f

  .elseif uMsg==WM_MOUSEWHEEL
    .if wParam>80000000h
      inc len
    .else
      dec len
    .endif
@@:
    invoke wsprintf,addr buf,offset _ft,len
    invoke SetWindowText,hWnd,addr buf
@@:
    invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE

  .elseif uMsg==WM_RBUTTONUP
    inc count
    mov eax,count
    .if eax==1
      mov ebx,0
    .elseif eax==2
      mov ebx,0
      invoke GetWindowLong,hWnd,GWL_STYLE
      mov ecx,eax
      or eax,WS_CAPTION
      .if ecx==eax
        and eax,not WS_CAPTION
      .endif        
      invoke SetWindowLong,hWnd,GWL_STYLE,eax
    .elseif eax==3
      mov count,0
      mov ebx,hmenu
    .endif
    invoke SetMenu,hWnd,ebx
    jmp @b

  .elseif uMsg==WM_NCCALCSIZE
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam  ;(!) lParam before DWP -> window rect, lParam after DWP -> client rect
    mov ebx,lParam
    mov ecx,len
    add dword ptr [ebx],ecx     ; .left
    add dword ptr [ebx+4],ecx   ; .top
    sub dword ptr [ebx+8],ecx   ; .right
    sub dword ptr [ebx+12],ecx  ; .bottom

  .elseif uMsg==WM_NCPAINT
    invoke GetWindowRect,hWnd,addr rt
    mov edi,rt.left
    mov esi,rt.top
    invoke DefWindowProc,hWnd,WM_NCCALCSIZE,FALSE,addr rt  ;  "legitimate" client rect (screen coordinates)
    mov eax,rt.left
    and eax,0ffffh
    mov ecx,rt.top
    shl ecx,16
    or eax,ecx
    mov lprm,eax  ; (x,y) -> lParam for WM_NC*
    sub rt.left,edi
    sub rt.top,esi
    sub rt.right,edi
    sub rt.bottom,esi
    invoke GetWindowLong,hWnd,GWL_STYLE  ; (also need test WS_EX_LEFTSCROLLBAR, WS_EX_LAYOUTRTL, ...)
    mov ebx,eax
    and eax,WS_VSCROLL
    .if eax!=0
      invoke GetSystemMetrics,SM_CXVSCROLL
    .endif
    add rt.right,eax
    push eax
    and ebx,WS_HSCROLL
    .if ebx!=0
      invoke GetSystemMetrics,SM_CYHSCROLL
    .endif
    add rt.bottom,eax
    push eax
    invoke GetClientRect,hWnd,addr rt2
    pop eax
    add rt2.bottom,eax
    pop eax
    add rt2.right,eax
    invoke MapWindowPoints,hWnd,0,addr rt2,2
    sub rt2.left,edi
    sub rt2.top,esi
    sub rt2.right,edi
    sub rt2.bottom,esi
    mov esi,rt.top
    mov eax,rt2.top
    mov rt.top,eax
    invoke CreateRectRgnIndirect,addr rt
    mov ebx,eax
    invoke CreateRectRgnIndirect,addr rt2
    push eax
    invoke CombineRgn,ebx,ebx,eax,RGN_DIFF
    call DeleteObject
    mov rt.top,esi
    invoke GetWindowDC,hWnd    
    mov esi,eax
    invoke GetStockObject,WHITE_BRUSH
    invoke FillRgn,esi,ebx,eax
    invoke DeleteObject,ebx
    invoke GetStockObject,DEFAULT_GUI_FONT
    invoke SelectObject,esi,eax
    mov edi,eax
    invoke SetBkMode,esi,TRANSPARENT
    invoke SetTextColor,esi,Blue
    mov ebx,offset _HTNOWHERE
    invoke lstrlen,ebx
    mov ecx,rt.left
    add ecx,2
    mov edx,rt.bottom
    sub edx,16
    invoke TextOut,esi,ecx,edx,ebx,eax
    mov eax,rt2.top
    mov rt.bottom,eax
    invoke GetStockObject,WHITE_BRUSH
    invoke FillRect,esi,addr rt,eax
    invoke DefWindowProc,hWnd,WM_NCHITTEST,0,lprm
    .if eax==HTNOWHERE
      mov ebx,offset _HTNOWHERE
    .elseif eax==HTCAPTION
      mov ebx,offset _HTCAPTION
    .elseif eax==HTMENU
      mov ebx,offset _HTMENU
    .else
      mov ebx,offset _OTHER
    .endif
    add rt.top,2
    sub rt2.top,2
    mov ecx,rt.left
    add rt.left,2
    .if ebx!=offset _HTNOWHERE
      invoke MoveToEx,esi,ecx,rt2.top,0
      invoke LineTo,esi,rt.right,rt2.top
    .endif
    invoke lstrlen,ebx
    invoke TextOut,esi,rt.left,rt.top,ebx,eax
    invoke SelectObject,esi,edi
    invoke ReleaseDC,hWnd,esi
    invoke InvalidateRect,hWnd,0,1
    jmp @dwp

  .elseif uMsg==WM_PAINT
    invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE
    invoke BeginPaint,hWnd,addr ps
    mov ebx,eax
    invoke GetStockObject,DEFAULT_GUI_FONT
    invoke SelectObject,ebx,eax
    mov edi,eax
    invoke SetBkMode,ebx,TRANSPARENT
    invoke SetTextColor,ebx,Blue
    invoke lstrlen,offset _HTCLIENT
    invoke TextOut,ebx,2,2,offset _HTCLIENT,eax
    invoke SetTextColor,ebx,Red
    invoke lstrlen,offset _text
    invoke TextOut,ebx,6,30,offset _text,eax
    invoke SelectObject,ebx,edi
    invoke EndPaint,hWnd,addr ps

  .elseif uMsg==WM_LBUTTONDOWN
    mov uMsg,WM_SYSCOMMAND
    mov wParam,SC_SIZE+9
    jmp @dwp

  .else
@dwp:
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    ret
  .endif
  xor eax,eax
  ret
WndProc endp

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
  local wc:WNDCLASSEX
  local msg:MSG
  local hWnd:HWND
  mov wc.cbSize,sizeof WNDCLASSEX
  mov wc.style,0
  mov wc.lpfnWndProc,offset WndProc
  mov wc.cbClsExtra,0
  mov wc.cbWndExtra,0
  mov eax,hInst
  mov wc.hInstance,eax
  mov wc.hbrBackground,COLOR_APPWORKSPACE
  mov wc.lpszMenuName,0
  mov wc.lpszClassName,offset _class
  invoke LoadIcon,0,IDI_APPLICATION
  mov wc.hIcon,eax
  mov wc.hIconSm,eax
  invoke LoadCursor,0,IDC_HAND
  mov wc.hCursor,eax
  invoke RegisterClassEx,addr wc
  invoke GetSystemMetrics,SM_CXSCREEN
  sub eax,320
  shr eax,1
  push eax
  invoke GetSystemMetrics,SM_CYSCREEN
  sub eax,250
  shr eax,1
  pop ecx
  invoke CreateWindowEx,WS_EX_CLIENTEDGE,offset _class,0,WS_OVERLAPPEDWINDOW OR WS_VSCROLL OR WS_HSCROLL,ecx,eax,390,300,0,0,hInst,0
  mov hWnd,eax
  invoke ShowWindow,hWnd,CmdShow
  invoke UpdateWindow,hWnd
  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
  .endw
  mov eax,msg.wParam
  ret
WinMain endp

start:
  invoke GetModuleHandle,0
  invoke WinMain,eax,0,0,SW_SHOWDEFAULT
  invoke ExitProcess,eax
end start
